// *****************************************************************************************************
// *******              speak2web VOICE FORMS                                                ***********
// *******               Get your subscription at                                            ***********
// *******                    https://speak2web.com/plugin#plans                             ***********
// *******               Need support? https://speak2web.com/support                         ***********
// *******               Licensed GPLv2+                                                     ***********
//******************************************************************************************************

window.AudioContext = window.AudioContext || window.webkitAudioContext;

var vfAudioContext = null;
var vfAudioInput   = null,
vfRealAudioInput   = null,
vfInputPoint       = null,
vfAudioRecorder    = null;
var vfRecIndex = 0;
var vfToken    = "";
var initCB     = null;
let vfStream   = null;

function vfGetToken() {
    if (!(typeof(vfXApiKey) != 'undefined' && vfXApiKey !== null)) return;

    // Check when last service log was updated
    try {
        let vfLastUpdatedAtTimestamp = vfServiceLogs.updatedAt || null;

        if (vfLastUpdatedAtTimestamp !== null) {
            vfLastUpdatedAtTimestamp = Number(vfLastUpdatedAtTimestamp);
            let currentUtcTimestamp = Math.round(new Date().getTime()/1000);

            // Add 24 hours to last updated timestamp
            vfLastUpdatedAtTimestamp = vfLastUpdatedAtTimestamp + (24 * 3600);

            // Check if last service call log update was older than 24 hours
            if (currentUtcTimestamp >= vfLastUpdatedAtTimestamp) {
                // Log service call count
                vfLogServiceCall(1);
            }
        }
    } catch (err) {
        // do nothing
    }

    // Check if token locally preserved. If yes then get it locally.
    var locallyPreservedToken = vfGetLocallyPreservedToken();

    if (typeof(locallyPreservedToken) != 'undefined' 
        && locallyPreservedToken !== null 
        && locallyPreservedToken.length != 0) {
        vfToken = locallyPreservedToken;
        return;
    }

    var xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function () {
        if (this.readyState == 4 && this.status == 200) {
            //alert(this.responseText);
            var res = JSON.parse(this.responseText);
            vfToken = res.token;
            // Preserve token locally
            vfPreserveToken(vfToken);
        }
    };

    try {
        xhttp.open("GET", vfTokenApiUrl, true);
        xhttp.setRequestHeader("Content-type", "application/json");
        xhttp.setRequestHeader("x-api-key", vfXApiKey);
        xhttp.send();
    } catch(err) {
        console.log('We had an error while availing token. Error:' + err.message);
    }
}

function vfGotStream(stream) {
    vfInputPoint = vfAudioContext.createGain();
    vfStream = stream;

    // Create an AudioNode from the stream.
    vfRealAudioInput = vfAudioContext.createMediaStreamSource(stream);
    vfAudioInput     = vfRealAudioInput;
    vfAudioInput.connect(vfInputPoint);
    
    vfAudioRecorder = new Recorder(vfInputPoint);
    initCB(vfAudioRecorder);
}

function vfInitAudio(cb) {
    vfGetToken();
    initCB = cb;
    vfAudioContext = new AudioContext();

    navigator.mediaDevices.getUserMedia({ "audio": !0 })
        .then(vfGotStream)
        .catch(function (e) {
            console.log("We caught en error while gaining access to audio input", e.message);
        }
    );
}

/**
 * Function to stop accessing audio resource
 *
 */
function vfStopAudio() {
    try {
        vfStream.getTracks().forEach(function (track) {
            track.stop();
        });

        vfAudioContext.close();    
        vfAudioContext = null;
    } catch(err) {
        console.log('VF Exception: Unable to release audio resource due to: ' + err.message);
    }
}
