// *****************************************************************************************************
// *******              speak2web VOICE FORMS                                                ***********
// *******               Get your subscription at                                            ***********
// *******                    https://speak2web.com/plugin#plans                             ***********
// *******               Need support? https://speak2web.com/support                         ***********
// *******               Licensed GPLv2+                                                     ***********
//******************************************************************************************************

// Cross browser 'trim()' funtion support
if (typeof String.prototype.trim !== 'function') { String.prototype.trim = function() { return this.replace(/^\s+|\s+$/g, ''); } }

var respTimeOut = false;
var errcnt    = 0;
var myStatus  = {};
var myContext = {};
var voice     = undefined;
var win1      = -1;
var win2      = -1;
var isTalking = false;
var isLoaded  = false;
var lang      = vfSelectedLang;
let vfHostName = typeof(vfCurrentHostName) != 'undefined' ? vfCurrentHostName : null;

var vfPreservedText = null, vfPreservedCallback = null, vfVoicesPopulated = false;

var vfDummySpeakButton = document.createElement('button');
vfDummySpeakButton.setAttribute('type', 'button');

/**
 * Function to get availale list of voices in the browser
 */
function vfPopulateVoiceList() {
    var speechSynthesis = window.speechSynthesis;

    if (typeof speechSynthesis === 'undefined') { return; }

    voices = speechSynthesis.getVoices();

    // Local function to get specific voice from available voices in browser
    var vfGetVoice = function(vfVoices, vfVoiceName = null, vfObjProp = 'name'){
        var vfFoundedVoice = null;
        try {
            for (vfI = 0; vfI < vfVoices.length; vfI++) {
                if (vfVoices[vfI][vfObjProp].indexOf(vfVoiceName) != -1) {
                    vfFoundedVoice = vfVoices[vfI];
                    break;
                }
            }
        } catch (err) { 
            vfFoundedVoice = null; 
        }

        return vfFoundedVoice;
    };

    //$$$$$$ AS OF NOW (2019 FIRST QUARTER) FIREFOX ON LINUX ONLY SUPPORT ROBOTIC MALE VOICE 
    //$$$$$$ THEREFORE THERE WILL ALWAYS BE A MALE VOICE ('en-US') ON DESKTOP LINUX AND ANDROID DEVICES
    switch (vfTypeOfSelectedLanguage.toLowerCase()) {
        case 'german':
            // Windows OS
            voice = vfGetVoice(voices, 'Hedda');

            //Chrome Browser
            if (typeof (voice) == 'undefined' || voice === null) { voice = vfGetVoice(voices, 'Google Deutsch') };

            // Everything else
            if (typeof (voice) == 'undefined' || voice === null) { voice = vfGetVoice(voices, 'German') }; 
            if (typeof (voice) == 'undefined' || voice === null) { voice = vfGetVoice(voices, 'german') }; 
            if (typeof (voice) == 'undefined' || voice === null) { voice = vfGetVoice(voices, 'de-DE', 'lang') };
            if (typeof (voice) == 'undefined' || voice === null) { voice = vfGetVoice(voices, 'de-DE', 'languageCode') };        
            if (typeof (voice) == 'undefined' || voice === null) { voice = vfGetVoice(voices, 'de-DE') };

            break;

        default:
            // Browsers on Windows OS 
            voice = vfGetVoice(voices, 'David');

            // Chrome Browser on any platform
            if (typeof(voice) == 'undefined' || voice === null) { voice = vfGetVoice(voices, 'Google UK English Male')};

            // Browsers on Mac and iOS
            if (typeof(voice) == 'undefined' || voice === null) { voice = vfGetVoice(voices, 'Alex')}; // en-US
            if (typeof(voice) == 'undefined' || voice === null) { voice = vfGetVoice(voices, 'Fred')}; // en-US
            if (typeof(voice) == 'undefined' || voice === null) { voice = vfGetVoice(voices, 'Daniel')}; // en-GB

            // Firefox browser on Linux
            if (typeof(voice) == 'undefined' || voice === null) { voice = vfGetVoice(voices, 'english-us')}; // en-US
            if (typeof(voice) == 'undefined' || voice === null) { voice = vfGetVoice(voices, 'english_rp')}; // en-GB          
        
    }

    if (!(typeof(voice) != 'undefined' && voice !== null)) {
        voice = vfGetVoice(voices, 'en-US', 'lang');

        if (typeof(voice) == 'undefined' || voice === null) { voice = vfGetVoice(voices, 'en_US', 'lang')}; // en_US (For android)
    }
}

vfPopulateVoiceList();

// Handle asynch behavior of Chrome browser to populate voice
if (typeof speechSynthesis !== 'undefined' && speechSynthesis.onvoiceschanged !== undefined) {
    speechSynthesis.onvoiceschanged = function() {
        vfVoicesPopulated = true;
        vfPopulateVoiceList();

        if (typeof(vfPreservedText) != 'undefined' && vfPreservedText !== null) {
            tts(vfPreservedText, vfPreservedCallback);
        } 

        vfPreservedText = null;
        vfPreservedCallback = null;
    }
}

function stt(blob, errorRecovery, cb) {
    if (errorRecovery == false) {
        let i = Math.floor(Math.random() * 10); 
        let resp = vfAlternativeResponse['randomLib'];
        
        if (respTimeOut == false) {
            tts(resp[i], function () { });
            respTimeOut = true;
            
            setTimeout(function () {
                respTimeOut = false;
            }, 6000);
        }
    }

    var wsURI           = vfWebSocketUrl.url + vfWebSocketUrl.tokenQs + vfToken + vfWebSocketUrl.otherQs;
    var websocket       = new WebSocket(wsURI);
    websocket.onopen    = function (evt) { onOpen(evt) };
    websocket.onclose   = function (evt) { onClose(evt) };
    websocket.onmessage = function (evt) { onMessage(evt) };
    websocket.onerror   = function (evt) { onError(evt) };

    function onOpen(evt) {
        // Log service call count
        vfLogServiceCall();

        let message = {
            'action': 'start',
            'content-type': 'audio/wav',
            'interim_results': false,
            'max_alternatives': 3,
            'smart_formatting': true,            
        };

        websocket.send(JSON.stringify(message));
        websocket.send(blob);
        websocket.send(JSON.stringify({ 'action': 'stop' }));
    }

    function onMessage(evt) {
        let res = JSON.parse(evt.data);

        if (res.results != undefined) {
            let msg = "";

            // we have a message coming back :-)
            var foundFinal = false;

            for (var k in res.results) {
                if (res.results[k].final == true) {
                    msg = msg + res.results[k].alternatives[0].transcript;
                    foundFinal = true;
                }
            }

            errcnt = 0;

            if (foundFinal == true || res.results.length == 0) {
                if (typeof(cb) === 'function') { cb(msg) };
                websocket.close();
            }
        }
    }

    function onError(evt) {
        errcnt++;
        websocket.close();

        if (!(typeof(vfXApiKey) != 'undefined' && vfXApiKey !== null)) { return; }

        if (errcnt < 2) {
            //$$$$$$$$$$$$$$$ FETCH NEW TOKEN MIGHT HAVE EXPIRED $$$$$$$$$$$$$$$$$$
            let xhttp = new XMLHttpRequest();
            
            xhttp.onreadystatechange = function () {
                if (this.readyState == 4 && this.status == 200) {
                    let res = JSON.parse(this.responseText);
                    vfToken   = res.token;

                    // Preserve token locally
                    vfPreserveToken(vfToken);

                    stt(blob,true,cb);
                }
            };

            try {
                xhttp.open("GET", vfTokenApiUrl, true);
                xhttp.setRequestHeader("Content-type", "application/json");
                xhttp.setRequestHeader("x-api-key", vfXApiKey);
                xhttp.send();
            } catch(err) {
                console.log('We had an error while availing expired token agina. Error:' + err.message);
            }
        }
    }

    function onClose(evt) { /* do nothing for now*/ }
}

function tts (text, callback) {
    let u = new SpeechSynthesisUtterance();
    let speechSynthesis = window.speechSynthesis;
    
    try {
        var l = document.getElementById("l1");

        if (l) { l.textContent = text; }
    } catch (err) { 
        // Do nothing
    }

    u.text = text;
    u.lang = lang;

    if (voice != 'undefined' && voice != null) { u.voice = voice; }

    if (vfVoicesPopulated === false && voice === null) {
        vfPreservedText = text;
        vfPreservedCallback = callback;
        return;
    } else {
        vfVoicesPopulated = false;
    }

    u.onend = function () {
        isTalking = false;
        
        if (callback) { callback(); }
    };

    u.onerror = function (e) {
        // In chrome 71 and above If page is reloaded or user have not yet 
        // interacted with page then 'not-allowed' constraint imposed.
        if (typeof(e.type) != 'undefined' && typeof(e.error) != 'undefined' 
            && e.type == 'error' && e.error == 'not-allowed') {
            isTalking = false;
            console.log('speechSynthesis not available');
            return;
        }

        if (callback) {
            //alert("Unable to speak!");
            callback(e);
        }
    };

    // Starting in Chrome 71, the speech synthesis API now requires some kind of user activation on the page 
    // before it’ll work. This brings it in line with other autoplay policies. 
    // If you try to use it before the user has interacted with the page, it will fire an error.
    try {
        isTalking = true;
        vfDummySpeakButton.onclick = function() { speechSynthesis.speak(u) };
        vfDummySpeakButton.click();
    } catch (err) {
        console.log('vf: speechSynthesis not available. Error:' + err.message);
    }
}

function tts_stop() {
    speechSynthesis.cancel();
}

/**
 * Function to locally preserve token
 * 
 * @param vfToken - string : Token
 */
function vfPreserveToken(vfThisToken = null) {
    try {
        if (vfThisToken === null) return;

        var currentUtcTimestamp = Math.round(new Date().getTime()/1000);
        vfThisToken = vfThisToken + '_vf_ts_' + currentUtcTimestamp;

        window.localStorage.setItem('vfToken', vfThisToken);
    } catch (err) {
        console.log('vf: Not able to preserve token. Error:' + err.message);
    }
}

/**
 * Function to retrieve a token from local storage
 *
 * @returns preservedToken - string: A token if preserved for more than 6 hours otherwise null.
 */
function vfGetLocallyPreservedToken() {
    var preservedToken = null;

    try {
        let localToken = window.localStorage.getItem('vfToken');

        if (!(localToken !== null  && localToken.length > 0)) { return preservedToken; }

        let tokenData = localToken.split('_vf_ts_');

        if (!(typeof(tokenData) != 'undefined' && tokenData !== null)) { return preservedToken; }

        if (tokenData.length < 2) { return preservedToken; }

        let tokenPreservanceTimestamp = tokenData[1];
        tokenPreservanceTimestamp     = Number(tokenPreservanceTimestamp);
        let currentUtcTimestamp       = Math.round(new Date().getTime()/1000);

        if (isNaN(tokenPreservanceTimestamp)) return preservedToken;

        // Add 6 hours to preservance time
        tokenPreservanceTimestamp = tokenPreservanceTimestamp + (6 * 3600);

        // Check if token has been preserved for more than 6 hours. If not then retrieve locally preserved token
        if (!(currentUtcTimestamp >= tokenPreservanceTimestamp)) {
            preservedToken = tokenData[0];
        } else {
            window.localStorage.removeItem('vfToken');
        }
    } catch (err) {
        preservedToken = null;
    }

    return preservedToken;
}

/**
 * Function to get current host/domain full URL
 *
 */
function vfGetCurrentHostURL() {
    var currentHostUrl = null;
    try {
        if (!(typeof(window.location) != 'undefined' 
            && typeof(window.location.hostname) != 'undefined' 
            && typeof(window.location.protocol) != 'undefined')) {
            return vfGetHostName();
        }

        var thisProtocol = window.location.protocol;
        var thisHostname = window.location.hostname;

        currentHostUrl = thisProtocol + '//' + thisHostname;
    } catch (err) {
        currentHostUrl = vfGetHostName();
        console.log('Something went wrong while discovering current domain.');
    }

    return currentHostUrl;
}

/**
 * Function to get current host name from backend.
 */
function vfGetHostName() {
    return vfHostName;
}

/**
 * Function to log STT service call
 *
 * @param {vfUpdateLastValue - int/Number} : 0 to not to update last value or 1 to update last value
 */
function vfLogServiceCall(vfUpdateLastValue = 0) {
    try {
        let vfXhr = new XMLHttpRequest();

        vfXhr.onreadystatechange = function () {
            if (this.readyState == 4 && this.status == 200) {
                let res = JSON.parse(this.responseText);

                // Update localized variables of service log 
                vfServiceLogs.updatedAt    = res.updatedAt || vfServiceLogs.updatedAt;
                vfServiceLogs.currentValue = res.currentValue || vfServiceLogs.currentValue;
                vfServiceLogs.lastValue    = res.lastValue || vfServiceLogs.lastValue;
            }
        };

        vfXhr.open("POST", vfAjaxObj.ajax_url , true); 
        vfXhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        vfXhr.send("action=vf_log_service_call&_ajax_nonce=" + vfAjaxObj.nonce + "&updateLastValue=" + vfUpdateLastValue);
    } catch (err) {
        // Do nothing for now
    }
}

/**
 * Function to sanitize/smartly format email to avoid text in a place of anticipated symbols
 *
 * @param { emailString: String } Email string to be formatted
 *
 * @returns { formattedEmail: String } Smartly formatted/sanitized email.
 */
function vfFormatEmail(emailString = null) {
    let formattedEmail = emailString;
    try {
        if (emailString && emailString !== null) {
            let vfEmail = emailString.toLowerCase();
            vfEmail = vfEmail.replace(/dot/gi, ".")
            .replace(/at/gi, "@")
            .replace(/underscore/gi, "_")
            .replace(/dotcom/gi, ".com")
            .replace(/dotorg/gi, ".org")
            .replace(/dotnet/gi, ".net")
            .replace(/dotint/gi, ".int")
            .replace(/dotedu/gi, ".edu")
            .replace(/ /g, "");

            formattedEmail = vfEmail;
        }
    } catch(err) {
        formattedEmail = emailString;
    }

    return formattedEmail;
}

